#include <QApplication>
#include <QDebug>
#include <QPrinter>
#include <QPrintDialog>
#include <QPainter>
#include <QImage>

int main(int argc, char **argv)
{
	QApplication app(argc, argv);
	QPrinter printer(QPrinter::HighResolution);
	QPrintDialog printDialog(&printer, this);
	if (printDialog.exec() == QDialog::Accepted) {
		QPainter painter(&printer);
		// Create an image.
		QImage im(7350, 9600, QImage::Format_ARGB32_Premultiplied);

		// If the device pixel ratio is not 1.0, the image is drawn as seperate blocks to the printer.
		im.setDevicePixelRatio(1.5);

		// Fill the image with red.
		im.fill(Qt::red);

		// Should fill the page with solid red.
		painter.drawImage(0, 0, im);
	}
}
